<?php

namespace App\Controllers\Front;

use App\Models\SitepageModel;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class SitepageController extends FrontController
{
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->_model = new SitepageModel();
        $this->_viewDatas['className'] = 'Sitepage';
        $this->_viewPath .= strtolower($this->_viewDatas['className']);
        $this->_viewDatas['title'] = lang($this->_viewDatas['className'] . '.title');
        $this->_viewDatas['class_icon'] = CLASS_ICONS[strtoupper($this->_viewDatas['className'])];
        helper($this->_viewDatas['className']);
    }
    public function getFields(string $action = ""): array
    {
        $fields = ["content"];
        switch ($action) {
            case "index":
            case "excel":
                return ['title', "created_at"];
                break;
            case "view":
                return ['title', "created_at", "content"];
                break;
            default:
                return $fields;
                break;
        }
    }
    public function getFieldFilters(): array
    {
        return [];
    }
    public function getFieldBatchFilters(): array
    {
        return parent::getFieldBatchFilters();
    }

    //Index관련
    protected function index_process()
    {
        //Category 확인
        $this->setCategory($this->request->getVar('category'));
        //권한체크
        $this->isRole('index');
        return parent::index_process();
    }
    //Category 및 Status 조건추가
    protected function index_condition()
    {
        $this->_model->where("category", $this->_viewDatas['currentCategory']->getPrimaryKey());
        $this->_model->where("status", DEFAULTS['STATUS']);
        parent::index_condition();
    }
}
